/*-
 * Copyright (C)2003 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C)2003 @BABOLO http://www.babolo.ru/\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: test.c,v 1.1 2004/02/02 03:32:57 babolo Exp $";
#endif /* not lint */

#include <sys/types.h>
#include <sysexits.h>
#include <stdlib.h>
#include <limits.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <err.h>
#include <babolo/BLINflag.h>
#include "../mife.h"
#define SEQN(i) ((((u_int32_t)(i) ^ 0x33CC55AA) >> (((u_int32_t)(i) & 3) * 7 + 2) | 0x80) & 0xFF)
#define SEEN(mf, of, i) (((u_char*)mife_get((mf), (of)))[i] & 0xFF)

int
main(int argc, char **argv) {
    int i, fd, pr;
    u_int32_t flag;
    ssize_t c, bl, pl;
    off_t of;
    struct mife_descriptor *mf;
    char *eoln;

    if  (!argv) exit(EX_USAGE);
    flag = MIFE_BUFX;
    fd = fileno(stdin);
    eoln = NULL;
    bl = 65536;
    pr = 0;
    while ((i = getopt(argc, argv, "b:fl:pqr:vx:")) > 0) {
        switch (i) {
        case 'b':
            bl = strtoul(optarg, NULL, 0);
            break;
        case 'f':
            flag |= MIFE_FULL;
            break;
        case 'l':
            flag |= MIFE_BUFX;
            flag |= strtoul(optarg, NULL, 0) << 8;
            break;
        case 'p':
            pr = 1;
            break;
        case 'q':
            flag &= ~BLIN_VERMASK;
            break;
        case 'r':
            fd = open(optarg, O_RDONLY);
            break;
        case 'v':
            flag |= ((flag & BLIN_VERMASK) << 1) | BLIN_VER1;
            break;
        case 'x':
            eoln = optarg;
            break;
        default:
            exit(EX_USAGE);
    }   }
    argc -= optind;
    argv += optind;
    if  (argc & 1) exit(EX_USAGE);
    mf = mife_opef(flag, fd);

    c = bl;
    if  (argc == 0) {
        for (i = 0, of = 0; c > 0 && !(mf->flag & MIFE_EOFL); i++, of += c) {
            c = mife_read(mf, bl, of, eoln);
            if  (pr && c >= 0) printf("i=%d %d l=%d\n", i, c, strlen(mife_get(mf, of)));
            for (pl = 0; pl < c; pl++) {
                if  (!eoln && SEEN(mf, of, pl) != SEQN(of + pl)) {
                    printf("off=%08llX+%08X %02X<>%02X\n", of, pl, SEEN(mf, of, pl), SEQN(of + pl));
        }   }   }
        printf("%d %d\n", i, c);
    } else {
        for (i = 0; argc; i++, argc -= 2) {
            bl = strtoul(*(argv++), NULL, 0);
            of = strtoq(*(argv++), NULL, 0);
            c = mife_read(mf, bl, of, eoln);
            if  (pr && c >= 0) printf("i=%d %d l=%d\n", i, c, strlen(mife_get(mf, of)));
            for (pl = 0; pl < c; pl++) {
                if  (!eoln && SEEN(mf, of, pl) != SEQN(of + pl)) {
                    printf("off=%08llX+%08X %02X<>%02X\n", of, pl, SEEN(mf, of, pl), SEQN(of + pl));
        }   }   }
        printf("%d %d\n", i, c);
    }
    exit(EX_OK);
}
